import { jsx as ___EmotionJSX } from "@emotion/core";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import Container from '../../shared-components/container';
import { ButtonContents, ButtonText } from '../../style';
import { linkButtonStyles } from './style';
var propTypes = {
  disabled: PropTypes.bool,
  children: PropTypes.node.isRequired,
  buttonType: PropTypes.oneOf(['primary', 'secondary', 'tertiary', 'quaternary']),
  as: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  onClick: PropTypes.func
};
var defaultProps = {
  disabled: false,
  buttonType: 'primary',
  as: 'a',
  onClick: function onClick() {}
};

var Link = function Link(_ref) {
  var disabled = _ref.disabled,
      children = _ref.children,
      buttonType = _ref.buttonType,
      as = _ref.as,
      onClick = _ref.onClick,
      textColor = _ref.textColor,
      rest = _objectWithoutProperties(_ref, ["disabled", "children", "buttonType", "as", "onClick", "textColor"]);

  var ContainerTag = as;
  return ___EmotionJSX(ContainerTag, _extends({
    css: linkButtonStyles({
      disabled: disabled,
      buttonType: buttonType,
      textColor: textColor
    }),
    disabled: disabled,
    onClick: !disabled ? onClick : function () {
      return false;
    }
  }, rest), ___EmotionJSX(ButtonContents, {
    hasIcon: false
  }, ___EmotionJSX(ButtonText, null, children)));
};

Link.propTypes = propTypes;
Link.defaultProps = defaultProps;
Link.Container = Container;
export default Link;