import { jsx as ___EmotionJSX } from "@emotion/core";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React from 'react';
import PropTypes from 'prop-types';

var OffClickWrapper =
/*#__PURE__*/
function (_React$Component) {
  _inherits(OffClickWrapper, _React$Component);

  function OffClickWrapper(props) {
    var _this;

    _classCallCheck(this, OffClickWrapper);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(OffClickWrapper).call(this, props));

    _this.addOffClickListener = function () {
      document.addEventListener('click', _this.handleOffClick, false);
    };

    _this.removeOffClickListener = function () {
      document.removeEventListener('click', _this.handleOffClick, false);
    };

    _this.handleOffClick = function (event) {
      var node = _this.containerRef.current;
      var onOffClick = _this.props.onOffClick;

      if (!node) {
        return;
      }

      if (node.contains(event.target)) {
        return;
      }

      onOffClick(event);
    };

    _this.containerRef = React.createRef();
    return _this;
  }

  _createClass(OffClickWrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.addOffClickListener();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeOffClickListener();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className;
      return ___EmotionJSX("div", {
        ref: this.containerRef,
        className: className
      }, children);
    }
  }]);

  return OffClickWrapper;
}(React.Component);

OffClickWrapper.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  onOffClick: PropTypes.func.isRequired
};
export default OffClickWrapper;