import { jsx as ___EmotionJSX } from "@emotion/core";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React from 'react';
import PropTypes from 'prop-types';
import { Global } from '@emotion/core';
import OffClickWrapper from '../offClickWrapper';
import { MainContainer, Trigger, TooltipBox } from './style';
var propTypes = {
  alignRightPercent: PropTypes.number,
  alignTopPercent: PropTypes.number,
  arrowAlign: PropTypes.oneOf(['left', 'middle', 'right']),
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]).isRequired,
  content: PropTypes.node,
  nudgeLeft: PropTypes.number,
  nudgeRight: PropTypes.number,
  nudgeTop: PropTypes.number,
  nudgeBottom: PropTypes.number,
  position: PropTypes.oneOf(['top', 'bottom']),
  defaultOpen: PropTypes.bool,
  display: PropTypes.bool
};
var defaultProps = {
  arrowAlign: 'middle',
  content: '',
  nudgeLeft: 0,
  nudgeRight: 0,
  nudgeTop: 0,
  nudgeBottom: 0,
  position: 'top',
  defaultOpen: false,
  display: true
};

var Tooltip =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Tooltip, _React$Component);

  function Tooltip() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Tooltip);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Tooltip)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      clicked: false,
      hovered: false
    };

    _this.onMouseEnter = function () {
      _this.setState({
        hovered: true
      });
    };

    _this.onMouseLeave = function () {
      _this.setState({
        hovered: false
      });
    };

    _this.onClick = function () {
      var clicked = _this.state.clicked;

      if (clicked) {
        // if clicked is true, we're about to update to false so remove class
        document.querySelector('body').classList.remove('cursor-pointer');
      } else {
        document.querySelector('body').classList.add('cursor-pointer');
      }

      _this.setState({
        clicked: !clicked
      });
    };

    _this.closeTooltip = function () {
      var clicked = _this.state.clicked;

      if (clicked) {
        document.querySelector('body').classList.remove('cursor-pointer');
      }

      _this.setState({
        clicked: false,
        hovered: false
      });
    };

    return _this;
  }

  _createClass(Tooltip, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
          clicked = _this$state.clicked,
          hovered = _this$state.hovered;
      var _this$props = this.props,
          alignRightPercent = _this$props.alignRightPercent,
          alignTopPercent = _this$props.alignTopPercent,
          arrowAlign = _this$props.arrowAlign,
          children = _this$props.children,
          content = _this$props.content,
          defaultOpen = _this$props.defaultOpen,
          display = _this$props.display,
          nudgeBottom = _this$props.nudgeBottom,
          nudgeLeft = _this$props.nudgeLeft,
          nudgeRight = _this$props.nudgeRight,
          nudgeTop = _this$props.nudgeTop,
          position = _this$props.position;
      var open = defaultOpen || clicked || hovered;
      return ___EmotionJSX(OffClickWrapper, {
        onOffClick: this.closeTooltip
      }, ___EmotionJSX(Global, {
        styles: {
          'body.cursor-pointer': {
            cursor: 'pointer'
          }
        }
      }), ___EmotionJSX(MainContainer, null, ___EmotionJSX(Trigger, {
        onClick: this.onClick,
        onMouseEnter: this.onMouseEnter,
        onMouseLeave: this.onMouseLeave
      }, children), ___EmotionJSX(TooltipBox, {
        alignRightPercent: alignRightPercent,
        alignTopPercent: alignTopPercent,
        arrowAlign: arrowAlign,
        nudgeLeft: nudgeLeft,
        nudgeRight: nudgeRight,
        nudgeTop: nudgeTop,
        nudgeBottom: nudgeBottom,
        open: open,
        displayTooltip: display,
        position: position
      }, content)));
    }
  }]);

  return Tooltip;
}(React.Component);

Tooltip.propTypes = propTypes;
Tooltip.defaultProps = defaultProps;
export default Tooltip;